Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000356Core InformTesting commandspublic2010-10-26 22:502014-05-07 07:33
ReporterRon Newcomb 
Assigned Tograham 
PrioritynormalSeveritymildReproducibilityalways
StatusclosedResolutionfixed 
PlatformPPCOSMac OS XOS Version10.4
Product Version6F95 
Target VersionFixed in Version6L02 
Summary0000356: RELATIONS dysfunction on "one to various" relations involving text (with solution)
DescriptionThe below code produces nothing on the left side and not text on the right.
--------------
> RELATIONS
offering:
   >=> <illegal scene>
--------------
and changing it to "one text to various things" with ( "'I heard about Donna.'" can offer yourself. ) produces
-------------
> RELATIONS
offering:
  <string ""I heard about Donna.""> >=>
------------------
Which is odd that it has <string...> wrapping the string.

One-to-various works with thing-to-things, scene-to-things, things-to-scene. Text seems the culprit.

Minimal Source Text To Reproduce
Offering relates one scene to various text.
The verb to be able to offer (it is possibly offered) implies the offering relation.

The entire game can offer "'I heard about Donna.'"

There is room.
TagsNo tags attached.
Effect(serious/mild) Game compiles but misbehaves
Attached Filespatch file icon rels_show.patch [^] (731 bytes) 2010-11-23 19:09 [Show Content]

- Relationships

-  Notes
(0000750)
EmacsUser (manager)
2010-10-28 18:16
edited on: 2010-10-28 18:17

Confirmed. A workaround follows:

- - - -
There is room.

Offering relates one scene to various text.
The verb to be able to offer (it is possibly offered) implies the offering relation.

Include (-
[ SwappedHashTableRelationHandler rel task X Y kov kx ky swap;
    kov = BlkValueRead(rel, RRV_KIND);
    kx = KindBaseTerm(kov, 0); ky = KindBaseTerm(kov, 1);
    switch (task) {
        RELS_SET_VALENCY:
            return RELATION_TY_SetValency(rel, X);
        RELS_TEST, RELS_ASSERT_TRUE, RELS_ASSERT_FALSE:
            return HashCoreRelationHandler(rel, task, ky, kx, Y, X, 0);
        RELS_LOOKUP_ANY:
            switch (Y) {
                RLANY_GET_X: Y = RLANY_GET_Y;
                RLANY_GET_Y: Y = RLANY_GET_X;
                RLANY_CAN_GET_X: Y = RLANY_CAN_GET_Y;
                RLANY_CAN_GET_Y: Y = RLANY_CAN_GET_X;
            }
        RELS_LOOKUP_ALL_X:
            task = RELS_LOOKUP_ALL_Y;
        RELS_LOOKUP_ALL_Y:
            task = RELS_LOOKUP_ALL_X;
        RELS_SHOW:
            swap=X;
            X=Y;
            Y=swap;
            swap=kx;
            kx=ky;
            ky=swap;
        RELS_LIST:
            switch (Y) {
                RLIST_ALL_X: Y = RLIST_ALL_Y;
                RLIST_ALL_Y: Y = RLIST_ALL_X;
            }
    }
    return HashCoreRelationHandler(rel, task, kx, ky, X, Y, 0);
];
[ CorrectReversal relation;
    if(relation-->RR_HANDLER==ReversedHashTableRelationHandler){
        relation-->RR_HANDLER=SwappedHashTableRelationHandler;
    }
];
-).

To correct the offering relation: (- CorrectReversal( (+ the offering relation +) ); -).
When play begins:
    correct the offering relation;
    now the entire game can offer "'I heard about Donna.'"
- - - -

(0000866)
jmcgrew (administrator)
2010-11-23 19:11

See attached patch.
(0002378)
graham (administrator)
2014-01-26 02:02

Fixed at last. Thanks, especially for supplying the patch, which really should have gone into 6G60.

- Issue History
Date Modified Username Field Change
2010-10-26 22:50 Ron Newcomb New Issue
2010-10-28 00:43 jmcgrew Assigned To => jmcgrew
2010-10-28 00:43 jmcgrew Status new => acknowledged
2010-10-28 18:16 EmacsUser Note Added: 0000750
2010-10-28 18:16 EmacsUser Status acknowledged => confirmed
2010-10-28 18:17 EmacsUser Note Edited: 0000750 View Revisions
2010-10-29 09:14 jmcgrew Status confirmed => assigned
2010-11-23 19:09 jmcgrew File Added: rels_show.patch
2010-11-23 19:11 jmcgrew Note Added: 0000866
2010-11-23 19:11 jmcgrew Assigned To jmcgrew => graham
2010-11-23 19:11 jmcgrew Summary RELATIONS dysfunction on "one to various" relations involving text => RELATIONS dysfunction on "one to various" relations involving text (with solution)
2014-01-26 02:02 graham Note Added: 0002378
2014-01-26 02:02 graham Status assigned => resolved
2014-01-26 02:02 graham Resolution open => fixed
2014-05-07 07:32 jmcgrew Fixed in Version => 6L02
2014-05-07 07:33 jmcgrew Status resolved => closed


Copyright © 2000 - 2010 MantisBT Group
Powered by Mantis Bugtracker